<?php

require_once 'database/DAO.class.php';


/**
 * Class MarcaModelo
 */
class MarcaModelo extends DAO {

    static protected $table_param = array(
        'table' => 'marcaModelo',
        'primary_key' => 'mm_id',
        'field_types' => array(
            'mm_id' => 'int',
            'mm_marca' => 'varchar',
            'mm_modelo' => 'varchar',
            'mm_anios_validos_list' => 'varchar'
        )
    );
    public function __construct() {
        self::setTableParam();
    }

    static public function getPrimaryKeyFieldName() {
        return strtolower(MarcaModelo::$table_param['primary_key']);
    }

    static private function setTableParam() {
        parent::$table_param = self::$table_param;
    }

    static public function getTableName() {
        return self::$table_param["table"];
    }

    static public function getModeloListForDropDown($marca) {
        self::setTableParam();

        $_ret = false;
        try {

            $_irows = self::getResults(false, "mm_marca = '$marca'", "mm_marca");
            $_ret = array();

            if ($_irows > 0) {
                while ($_data = self::getNextRow()) {
                    if ($_data !== null) {

                        $_anios = $_data["mm_anios_validos_list"];
                        if($_anios)
                            $_anios = explode(",",$_anios);

                        $_ret[] = array(
                            "modelo" => $_data["mm_modelo"],
                            "anio" => $_anios
                        );
                    }
                }
            }

        } catch (Exception $e) {
            echo $e->getMessage();
        }

        return $_ret;
    }



    static public function getMarcaListForDropDown($term) {
        self::setTableParam();

        $_ret = false;
        try {
            $_query = "SELECT distinct mm_marca FROM marcaModelo WHERE mm_marca like '%$term%' order by mm_marca";

            $_irows = self::getResultsFromQuery($_query);
            $_ret = array();

            if ($_irows > 0) {
                while ($_data = self::getNextRow()) {
                    if ($_data !== null) {
                        $_ret[] = array(
                            "id" => $_data["mm_marca"],
                            "text" => $_data["mm_marca"]
                        );
                    }
                }
            }

        } catch (Exception $e) {
            echo $e->getMessage();
        }

        return $_ret;
    }

}